/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\ E D I T A B L E . C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#include "eazy_gem.h"
/* end of include.......................................................... */


/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/


/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*.................... EXTERNES AU MODULE .............................*/
/*                       IMPORTEES                                     */
extern void   ObjcOFsetToCoord(INT16 *x, INT16 *y, INT16 *w, INT16 *h, INT16 ofset, INT16 flag);
extern INT16  SetSystemFont(OBJECT *object, INT16 te_fnt);
extern INT16  SetObjcInterior(OBJECT *object);
extern void   DrawObjcCadre(OBJECT *object,PARMBLK *parmblock);

/*.................... INTERNES AU MODULE .............................*/

/*exportes*/
INT16 EZobjc_edit(OBJECT *object,INT16 ind, INT16 key,INT16 *poscur,INT16 flag);
INT16 MousexToCarEdit( OBJECT *object, INT16 ind, INT16 mx);
void XtextObAffi(INT16 txt_x, INT16 txt_y, char *txt, INT16 color, INT16 w_mode);
void UndoSet(NEW_EDIT *newedit, INT16 poscur);

/*internes*/
char IsCarTedinfoValid(char valid, char c);
void ObjcAffCurs(OBJECT *object,INT16 ind, INT16 txt_x, INT16 txt_y, INT16 poscur, char *pt_tmpl, char *txt, INT16 flag);
char _lower(char ch);
char _upper(char ch);
void  DrawObjcTextCadre(OBJECT *object, INT16 txt_x, INT16 txt_y );
void  DrawObjcBlkEdit(OBJECT *object, INT16 txt_x, INT16 txt_y );
INT16 EditableTextMix(char *txt, char *tmpl, char *buft, INT16 poscur);
INT16 FindDebMot(char *txt, INT16 i);
INT16 FindEndMot(char *txt, INT16 i);
void  GetPosAffiTxt(OBJECT *object, INT16 ind, NEW_EDIT *newedit, INT16 *txt_x, INT16 *txt_y, GRECT *grect);
INT16 DrawEditableCursor(OBJECT *object, INT16 ind, INT16 poscur);
void  DrawObjcBlkEdit_1(NEW_EDIT* newedit, INT16 txt_x, INT16 txt_y );
void  DrawObjcBlkEdit_2(NEW_EDIT* newedit, INT16 txt_x, INT16 txt_y );
INT16 CarEditToX(char *txt, int pos_car);
void  EditableUndoSet(OBJECT *object, INT16 ind, INT16 poscur);
INT16 EditableUndoGet(OBJECT *object, INT16 ind);


/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
static char  Undo_te_ptext[512];
static INT16 UndoPosCurs=0;
static INT16 UndoBlkDeb=0;
static INT16 UndoBlkEnd=0;
static INT16 UndoLeftOfs=0;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                          */
/*           implementation des fonctions de ce module)                        */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*------------------------------- UndoSet -------------------------------------*/
void EditableUndoSet(OBJECT *object, INT16 ind, INT16 poscur)
{NEW_EDIT *newedit  = (NEW_EDIT*) object[ind].ob_spec.userblk->ub_parm;
 strcpy(Undo_te_ptext, newedit->tedinfo->te_ptext);
 UndoPosCurs  = poscur;
 UndoBlkDeb   = newedit->BlkDeb;
 UndoBlkEnd   = newedit->BlkEnd;
 UndoLeftOfs  = newedit->LeftOfset;
}

/*------------------------------- UndoGet -------------------------------------*/
INT16 EditableUndoGet(OBJECT *object, INT16 ind)
{NEW_EDIT *newedit  = (NEW_EDIT*) object[ind].ob_spec.userblk->ub_parm;
 long len           = Min(strlen(Undo_te_ptext), newedit->tedinfo->te_txtlen - 1);
 memcpy(newedit->tedinfo->te_ptext, Undo_te_ptext, len);
 newedit->tedinfo->te_ptext[len] = 0;
 newedit->BlkDeb    = UndoBlkDeb;
 newedit->BlkEnd    = UndoBlkEnd;
 newedit->LeftOfset = UndoLeftOfs;
 return UndoPosCurs;
}

/*------------------------------- EZobjc_edit ---------------------------------*/
INT16 EZobjc_edit(OBJECT *object,INT16 ind, INT16 key,INT16 *poscur,INT16 flag)
{INT16 ob_xtype  = GET_XOBTYPE(object, ind);
 /*.................. exclure ce qui n'est pas bon ...................*/
 if (ind == -1 || ob_xtype==SCROLL_EDIT)          return -1;
 if (GET_OBTYPE(object, ind) != G_USERDEF)        return -1;
 if (!(ob_xtype==G_FBOXTEXT||ob_xtype==G_FTEXT))  return -1;
{char buft[512];
 INT16 txt_x;
 INT16 txt_y;
 NEW_EDIT *newedit  = (NEW_EDIT*) object[ind].ob_spec.userblk->ub_parm;
 TEDINFO  *tedinfo  = newedit->tedinfo;
 char        *tmpl  = tedinfo->te_ptmplt;
 char         *txt  = tedinfo->te_ptext;
 INT16     txtlen   = tedinfo->te_txtlen - 1;
 char      *valid   = tedinfo->te_pvalid;
 char        scan   = (char)(key>>8);
 char          car  = (char)key;
 INT16        ksp   = (INT16)Kbshift(-1);

 /*................. relever position texte .........................*/
 GetPosAffiTxt(object, ind, newedit, &txt_x, &txt_y, 0);
 /*.............. ajuster posiion curseur ...........................*/
 *poscur = Min(*poscur,(INT16)strlen(txt));
 /*................... interpretation touche clavier ................*/
 if (flag==ED_CHAR)
    { switch (scan)
        {case 97:                    /*.... UNDO...............*/
              DrawEditableCursor(object,ind, *poscur);
              *poscur = EditableUndoGet(object, ind);
              ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
              ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
              DrawEditableCursor(object,ind, *poscur);
              Mouse_on();
              return 1;
         case 77:                     /*.... fleche droite ....*/
           if (txt[*poscur])
              {DrawEditableCursor(object,ind, *poscur);
               if (ksp&0x0003)   *poscur  =(INT16)strlen(txt);
               else              *poscur +=1;
               /*......... tester si scrolling .................*/
               /*             du champ texte                    */
               if (newedit->Old_txtlen                                &&
                   (*poscur-newedit->LeftOfset>=newedit->Old_txtlen-1)
                  )
                  {if (ksp&0x0003)
                       newedit->LeftOfset  = Max(0,(INT16)strlen(txt) - Max(1, newedit->Old_txtlen>>2));
                   else
                       newedit->LeftOfset += Max(1, newedit->Old_txtlen>>2);
                   newedit->LeftOfset  = Min(newedit->LeftOfset, tedinfo->te_txtlen-newedit->Old_txtlen);
                   ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                   ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                  }
               DrawEditableCursor(object,ind, *poscur);
               Mouse_on();
               return 1;
              }
           break;
         case 75:                     /*.... fleche gauche ....*/
           if (*poscur)
              {DrawEditableCursor(object,ind, *poscur);
               if (ksp&0x0003)   *poscur  = 0;
               else              *poscur -=1;
               /*......... tester si scrolling .................*/
               /*             du champ texte                    */
               if (newedit->LeftOfset                                 && 
                   (*poscur- newedit->LeftOfset<=0)
                  )
                  {if (ksp&0x0003)
                       newedit->LeftOfset  = 0;
                   else
                       newedit->LeftOfset -= Max(1, newedit->Old_txtlen>>2);
                   newedit->LeftOfset  = Max(newedit->LeftOfset, 0);
                   ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                   ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                  }
               DrawEditableCursor(object,ind, *poscur);
               Mouse_on();
               return 1;
              }
           break;
         default:
              {/*.............. effacer curseur .......................*/
               DrawEditableCursor(object,ind, *poscur);
               /*............... relever reperes de bloc ..............*/
               if (newedit->BlkDeb > newedit->BlkEnd) SWAPW(newedit->BlkEnd, newedit->BlkDeb)
               switch (car)
                 {case 1:
                    if (newedit->BlkDeb | newedit->BlkEnd )
                        ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                    newedit->BlkDeb = 0;
                    newedit->BlkEnd = (INT16)strlen(txt);
                    ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                    DrawEditableCursor(object,ind, *poscur);
                    Mouse_on();
                    return 1;
                  case 2:         /*........... CTRL B ............*/
                    if (newedit->BlkDeb | newedit->BlkEnd )
                        ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                    if (ksp&3)
                       {newedit->BlkDeb = 0;
                        newedit->BlkEnd = (INT16)strlen(txt);
                       }
                    else
                       {newedit->BlkDeb = FindDebMot(txt, *poscur);
                        newedit->BlkEnd = FindEndMot(txt, *poscur);
                       }
                    ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                    DrawEditableCursor(object,ind, *poscur);
                    Mouse_on();
                    return 1;


                  case 'C':
                  case 'c':        /*.......CTRL+-SHIFT "C" .......*/
                  case  3:
                    if (ksp > 3 && newedit->BlkDeb | newedit->BlkEnd )
                       {ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_BLKAFF);
                        memcpy (buft,&txt[newedit->BlkDeb],txtlen);
                        buft[(INT16)(newedit->BlkEnd-newedit->BlkDeb)] = 0;
                        if (ksp&0x0003)
                           {ClipboardSave(buft,O_WRONLY|O_APPEND|O_CREAT); /* shift */
                           }
                        else
                           {ClipboardSave(buft,O_WRONLY|O_CREAT|O_TRUNC); /* shift */
                           }
                        ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_BLKAFF);
                        car = 0;
                       }
                    break;

                  case 'X':
                  case 'x':        /*.....CTRL+-SHIFT "X" .......*/
                  case 0x18:
                    if (ksp > 3 && newedit->BlkDeb | newedit->BlkEnd )
                       {EditableUndoSet(object, ind, *poscur);
                        ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_BLKAFF);
                        memcpy (buft,&txt[newedit->BlkDeb],txtlen);
                        buft[(INT16)(newedit->BlkEnd-newedit->BlkDeb)] = 0;
                        if (ksp&0x0003)
                           {ClipboardSave(buft,O_WRONLY|O_APPEND|O_CREAT); /* shift */
                           }
                        else
                           {ClipboardSave(buft,O_WRONLY|O_CREAT|O_TRUNC);          /* shift */
                           }
                        memcpy(txt+newedit->BlkDeb, txt+newedit->BlkEnd, txtlen - newedit->BlkEnd + 1);
                        *poscur =  newedit->BlkDeb;
                        newedit->BlkDeb = 0;
                        newedit->BlkEnd = 0;
                        /*........... si curseur non visible le recentrer ....................*/
                        if (newedit->Old_txtlen     &&
                            (*poscur<newedit->LeftOfset || 
                             *poscur - newedit->LeftOfset > newedit->Old_txtlen
                            )
                           )
                           {newedit->LeftOfset  = Max(0 , *poscur - (newedit->Old_txtlen>>2));
                           }
                        ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                        car = 0;
                       }
                    break;

                  case 'V':
                  case 'v':        /*.....CTRL+-SHIFT "V" .......*/
                  case 0x16:
                    if (ksp > 3)
                       {INT16 i = (INT16)ClipboardLoad(buft,txtlen);
                        EditableUndoSet(object, ind, *poscur);
                        ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_BLKAFF);
                        if (i>0)
                           {if (newedit->BlkDeb | newedit->BlkEnd )
                               {memcpy(txt+newedit->BlkDeb, txt+newedit->BlkEnd, txtlen - newedit->BlkEnd + 1);
                                *poscur = newedit->BlkDeb;
                               }
                            else
                               {newedit->BlkDeb = *poscur;
                               }
                            i=(INT16)strlen(buft);

                            memcpy(buft + newedit->BlkDeb, buft, i+1);          /* place pour debut txt->BlkDeb */
                            memcpy(buft, txt, newedit->BlkDeb);                 /* copier debut du texte        */
                            strcpy(buft+newedit->BlkDeb+i,txt+newedit->BlkDeb); /* copier fin du texte          */
                            buft[txtlen]=0;                                     /* limiter fin du texte         */
                            memcpy(txt,buft,txtlen+1);
                            newedit->BlkEnd = Min((INT16)strlen(txt), newedit->BlkDeb+i);
                            *poscur = newedit->BlkEnd;
                            /*........... si curseur non visible le recentrer ....................*/
                            if (newedit->Old_txtlen           &&
                                (*poscur < newedit->LeftOfset || 
                                 *poscur - newedit->LeftOfset > newedit->Old_txtlen
                                )
                               )
                               {newedit->LeftOfset  = Max(0 , *poscur - (newedit->Old_txtlen>>2));
                               }
                            ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                           }
                        if (newedit->BlkDeb==newedit->BlkEnd) newedit->BlkDeb=newedit->BlkEnd=0;
                        ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_BLKAFF);
                        car = 0;
                       }
                    break;
                 }  /* end switch  */


               /*..........  ce stade seules insertion Basckspace delete ..............*/

               /*......... si bloc defini ..............................................*/
               EditableUndoSet(object, ind, *poscur);
               if (car !=0 && newedit->BlkDeb != newedit->BlkEnd)
                  {if (newedit->BlkDeb > newedit->BlkEnd) SWAPW(newedit->BlkDeb,newedit->BlkEnd);
                   /*........ SI curseur contigu ou dans le bloc on efface le bloc ..........*/
                   if (*poscur>=newedit->BlkDeb && *poscur<=newedit->BlkEnd)
                      {ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt,ED_BLKAFF);
                       memcpy(txt+newedit->BlkDeb, txt+newedit->BlkEnd, txtlen - newedit->BlkEnd + 1);
                       *poscur = newedit->BlkDeb;
                       /*........... si curseur non visible le recentrer ....................*/
                       if (newedit->Old_txtlen  &&
                           (*poscur<newedit->LeftOfset || *poscur - newedit->LeftOfset > newedit->Old_txtlen
                           )
                          )
                          {newedit->LeftOfset  = Max(0 , *poscur - (newedit->Old_txtlen>>2));
                          }
                       ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                       if (car==8 || car==127) car = 0;
                      }
                   /*........ SINON on le deselectionne .....................................*/
                   else
                      {ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt,ED_BLKAFF);
                      }
                   newedit->BlkDeb = 0;
                   newedit->BlkEnd = 0;
                  }

               switch (car)
                  {
                   case 8:            /*.... backspace ..................*/
                     if (*poscur>0)
                        {if (newedit->Old_txtlen && 
                             (*poscur- newedit->LeftOfset - 1<0)
                            )
                            {newedit->LeftOfset -= Max(1, newedit->Old_txtlen>>2);
                             newedit->LeftOfset  = Max(newedit->LeftOfset, 0);
                             memcpy(txt+*poscur-1, txt+*poscur, txtlen - *poscur + 1);
                             *poscur -= 1;
                             ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                            }
                         else
                            {ObjcAffCurs(object, ind, txt_x, txt_y, *poscur-1, tmpl, txt, ED_ERASE);
                             memcpy(txt+*poscur-1, txt+*poscur, txtlen - *poscur + 1);
                             *poscur -= 1;
                             ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_STR);
                            }
                         
                        }
                     break;
                   case 27:            /*.... escape ....................*/
                     ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ERASE);
                     *poscur = 0;
                     *txt  = 0;
                     ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_STR);
                     if (newedit->LeftOfset                                 && 
                         (*poscur- newedit->LeftOfset<=0)
                        )
                        {newedit->LeftOfset = 0;
                         ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                        }
                     break;
                   case 127:           /*.... delete ....................*/
                     ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_ERASE);
                     if (txt[*poscur]) memcpy(txt+*poscur, txt+*poscur+1, txtlen - *poscur + 1);
                     ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_STR);
                     break;
                   default:           /*.... insertion de caracteres.... */
                     car = IsCarTedinfoValid(valid[*poscur], car);
                     if (car !=0            &&
                         txtlen - *poscur>0
                        )
                        {ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_ERASE);
                         memcpy(txt+*poscur+1, txt+*poscur, txtlen - *poscur);
                         txt[*poscur]=car;
                         txt[txtlen]=0;
                         ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, ED_STR);
                         *poscur = Min(txtlen, *poscur +1);
                         if (newedit->Old_txtlen && 
                             (*poscur-newedit->LeftOfset>=newedit->Old_txtlen-1)
                            )
                            {newedit->LeftOfset += Max(1, newedit->Old_txtlen>>2);
                             newedit->LeftOfset  = Min(newedit->LeftOfset, tedinfo->te_txtlen-newedit->Old_txtlen);
                             ObjcAffCurs(object, ind, txt_x, txt_y, 0, tmpl, txt, ED_ALL_REDRAW);
                            }
                        }
                   }
               /*.............. afficher curseur .......................*/
               DrawEditableCursor(object,ind, *poscur);
               Mouse_on();
               return 1;
              }
         /*case 80:*/                     /*.... fleche basse ....*/
         /*case 72:*/                     /*.... fleche haute ....*/
         /*case 97:*/                     /*.... undo ....*/
         /*case 28:*/                     /*.... return ....*/
         /*case 114:*/                    /*.... enter ....*/
        } /* end switch */
    }   /* endif ED_CHAR */
 else
    {ObjcAffCurs(object, ind, txt_x, txt_y, *poscur, tmpl, txt, flag);
    }
 return 1;
}
}

/*--------------------------- ObjcAffCurs --------------------------------*/
void ObjcAffCurs(OBJECT *object, INT16 ind, INT16 txt_x, INT16 txt_y, INT16 poscur, char *tmpl, char *txt, INT16 flag)
{char buft[512];
 INT16 i;
 char save_car;
 INT16 width_txt;
 EXTND_DIM strdim;
 INT16 vectxy [6];
 NEW_EDIT *newedit  = (NEW_EDIT*) object[ind].ob_spec.userblk->ub_parm;
 TEDINFO  *tedinfo  = newedit->tedinfo;
 
 Mouse_off();
 /*.................. melanger template et chaine .......................*/
 i = EditableTextMix(txt, tmpl, buft, poscur);
 save_car=buft[i];
 buft[i]=0;                                                         /* tronquer au curseur     */
 vqt_extent(VDIhandle, buft + newedit->LeftOfset,(INT16*)&strdim);  /* calcul position curseur */
 width_txt = strdim.XinfD - strdim.XinfG;                           /* largeur chaine -> curs  */
 buft[i]=save_car;


 /*..............................effacer  droite texte .................*/

 if (flag==ED_ERASE)
    {SetObjcInterior(&object[ind]);
     vswr_mode(VDIhandle,1);
     vqt_extent(VDIhandle, &buft[i],(INT16*)&strdim);  /* calcul rectangle a effacer */
     vectxy[0] = txt_x + width_txt;
     vectxy[1] = txt_y - newedit->height_txt+1; /*(strdim.YsupD-strdim.YinfD);  */
     vectxy[2] = Min(txt_x + width_txt + (strdim.XinfD - strdim.XinfG), txt_x + newedit->width_txt - 1);
     vectxy[3] = txt_y ;
     vr_recfl(VDIhandle,vectxy);
     Mouse_on();                                                      return ;
    }
if (flag==ED_ALL_REDRAW)
    {SetObjcInterior(&object[ind]);
     vswr_mode(VDIhandle,1);
     vectxy[0] = txt_x;
     vectxy[1] = txt_y - newedit->height_txt - 2;
     vectxy[2] = txt_x + newedit->width_txt;
     vectxy[3] = txt_y + 3;
     Clip(vectxy[0]-1, vectxy[1], vectxy[2], vectxy[3]);
     vr_recfl(VDIhandle,vectxy);
     if (tedinfo->te_color & 0x0080)
         vswr_mode(VDIhandle,1);       /* mode transparent       */
     else
         vswr_mode(VDIhandle,2);       /* mode replace           */
     v_gtext(VDIhandle, txt_x, txt_y, buft + newedit->LeftOfset);
     DrawObjcTextCadre(&object[ind], txt_x, txt_y );
     Mouse_on();                                                      return ;
    }
 /*.............................. afficher le texte .....................*/
 if (flag==ED_CHAR || flag==ED_STR )
    {if (tedinfo->te_color & 0x0080)
         vswr_mode(VDIhandle,1);       /* mode transparent       */
     else
         vswr_mode(VDIhandle,2);       /* mode replace           */
     vqt_extent(VDIhandle,&buft[i],(INT16*)&strdim);  /* calcul rectangle a effacer */
     vectxy[0] = txt_x + Max(0, width_txt-2);
     vectxy[1] = txt_y - newedit->height_txt - 2; /*(strdim.YsupD-strdim.YinfD);  */
     vectxy[2] = Min(txt_x + width_txt + (strdim.XinfD - strdim.XinfG), txt_x + newedit->width_txt);
     vectxy[3] = txt_y + 3;
     Clip(vectxy[0]-1, vectxy[1], vectxy[2], vectxy[3]);
     v_gtext(VDIhandle,txt_x + width_txt, txt_y,buft+i);
     DrawObjcTextCadre(&object[ind], txt_x, txt_y );
     Mouse_on();                                                      return;
    }

 /*.............................. afficher block ........................*/
 if ( flag == ED_BLKAFF && newedit->BlkDeb != newedit->BlkEnd)
    {DrawObjcBlkEdit( &object[ind], txt_x, txt_y );
     Mouse_on();                                                      return;
    }
 Mouse_on();
}

/*------------------------------ GetPosAffiTxt ----------------------------------*/
void GetPosAffiTxt(OBJECT *object, INT16 ind, NEW_EDIT *newedit, INT16 *txt_x, INT16 *txt_y, GRECT *grect)
{/*............. position de l'objet editable .......................*/
 INT16 thickness = newedit->tedinfo->te_thickness;
 INT16      ob_w = object[ind].ob_width;
 INT16      ob_h = object[ind].ob_height;
 
 objc_offset(object, ind, txt_x, txt_y);
 
 
 /*.......... corriger la position reelle de l'objet ..............*/
 if (object[ind].ob_flags & 0x0800) thickness = -4; /* texte encadre */
 if (thickness<0)
    {ObjcOFsetToCoord(txt_x,
                      txt_y,
                      &ob_w,
                      &ob_h,
                     thickness-1,
                     1);
    }
 
 /*........ determiner le texte .....................................*/
 vst_color (VDIhandle,(newedit->tedinfo->te_color>>8)&0x000F);
 SetSystemFont(object, newedit->tedinfo->te_font);
 /*............. positionner premier car  afficher .................*/
 
 switch (newedit->tedinfo->te_just)
 {case 0:                                             break;
  case 1: *txt_x +=   ob_w - newedit->width_txt;      break;
  case 2: *txt_x +=  (ob_w - newedit->width_txt)>>1;  break;
 }
 *txt_y          +=  (ob_h >>1) + (newedit->height_txt>>1);
 /*............... retourne le rectangle encadrant le texte .........*/
 /*            ( cliper pour affichage meme du cadre texte)         */
 if (grect)
    {/*
     grect->g_x = txt_x;
     grect->g_y = txt_y - newedit->height_txt - 2;
     grect->g_w = newedit->width_txt;
     grect->g_h = txt_y + 3;
     */
     
     grect->g_x = *txt_x - 1;
     grect->g_y = *txt_y - newedit->height_txt - 3;
     grect->g_w = newedit->width_txt  + 2;
     grect->g_h = newedit->height_txt + 7;
     
    }
}

/*-------------------------- DrawEditableCursor -----------------------------*/
INT16 DrawEditableCursor(OBJECT *object, INT16 ind, INT16 poscur)
{INT16 ob_xtype  = GET_XOBTYPE(object, ind);
 /*.................. exclure ce qui n'est pas bon ...................*/
 if (ind == -1 || ob_xtype==SCROLL_EDIT)          return -1;
 if (GET_OBTYPE(object, ind) != G_USERDEF)        return -1;
 if (!(ob_xtype==G_FBOXTEXT||ob_xtype==G_FTEXT))  return -1;

{char buft[512];
 INT16 width_txt, vectxy[4];
 INT16 txt_x;
 INT16 txt_y;
 EXTND_DIM strdim;
 NEW_EDIT *newedit = (NEW_EDIT*) object[ind].ob_spec.userblk->ub_parm;
 /*.................. melanger template et chaine .......................*/
 /*                   et calcul de la position curseur                   */
 INT16           i = EditableTextMix(newedit->tedinfo->te_ptext, newedit->tedinfo->te_ptmplt, buft, poscur);
 char     save_car = buft[i];  buft[i]=0;     /* tronquer au curseur     */
 /*............ faire GetPosAffiTxt() avant vqt_extent() ................*/
 /*      car positionne bons attributs texte pour vqt_extent()           */
 GetPosAffiTxt(object, ind, newedit, &txt_x, &txt_y, 0);
 vqt_extent(VDIhandle, buft + newedit->LeftOfset, (INT16*)&strdim);      /* calcul position curseur */
 width_txt         = strdim.XinfD - strdim.XinfG;                        /* largeur chaine -> curs  */
 buft[i]=save_car;
 
 Mouse_off();
 vsl_ends  (VDIhandle,0,0);
 vsl_width (VDIhandle,1);
 vsl_type  (VDIhandle,1);
 vswr_mode (VDIhandle,3);
 vsl_color (VDIhandle,1);
 vectxy[0] = txt_x + (strdim.XinfD - strdim.XinfG);  /* largeur du texte */
 vectxy[1] = txt_y - (strdim.YsupD - strdim.YinfD)-2; /*(strdim.YsupD-strdim.YinfD);  */
 vectxy[2] = txt_x + width_txt;
 vectxy[3] = txt_y + 3;
 v_pline   (VDIhandle,2,vectxy);
 vectxy[0] -=1;
 vectxy[2] -=1;
 v_pline   (VDIhandle,2,vectxy);
 return i;
}
}
 
/*-------------------------- IsCarTedinfoValid ------------------------------*/
char IsCarTedinfoValid(char valid, char c)
{switch (valid)
   {
   case 'l':
   case 'L':
      if (c>=16 && c<=25)
         return (c);
      else if (c>='0' && c<='9')
         return (c - '0' + 16);
      break;
   case 'c':
   case 'C':
      if (strchr(".+-*/^()[]{}",c))
         return (c);
      else if (c==',')
         return ('.');
   case '0':
   case '1':
   case '2':
   case '3':
   case '4':
   case '5':
   case '6':
   case '7':
   case '8':
   case '9':
      if (c>='0' && c<=valid)
         return (c);
      break;
   case 'h':
      c = _lower(c);
      if ((c>='0' && c<='9') || (c>='a' && c<='f'))
         return (c);
      break;
   case 'H':
      c = _upper(c);
      if ((c>='0' && c<='9') || (c>='A' && c<='F'))
         return (c);
      break;
   case 'N':
      if (c>='0' && c<='9')
         return (c);
   case 'A':
      c = _upper(c);
      if ((c>='A' && c<='Z') || c==' ')
         return (c);
      break;
   case 'n':
      if (c>='0' && c<='9')
         return (c);
   case 'a':
      c = _lower(c);
      if ((c>='a' && c<='z') || c==' ')
         return (c);
      break;
   case 'P':
      if (c=='\?' || c=='*')
         return (c);
   case 'p':
      if (c=='.' || c==':' || c=='\\')
         return (c);
   case 'F':
      if ((c>='A' && c<='Z') || (c>='a' && c<='z') || (c>='0' && c<='9') || strchr(" _!@#$%^&()+-=~\'`;\",<>|[]{}",c))
         return (c);
      break;
   case 'U':
      c = _upper(c);
      if (c>=32 && c<=127)
         return (c);
      break;
   case 'u':
      c = _lower(c);
      if (c>=32 && c<=127)
         return (c);
      break;
   case 'V':
      c = _upper(c);
      if (c>=32)
         return (c);
      break;
   case 'v':
      c = _lower(c);
      if (c>=32)
         return (c);
      break;
   case 'w':
   case 'W':
      if (c>=32 && c<=127)
         return (c);
      break;
   case 'y':
   case 'Y':
      if (c>=32)
         return (c);
      break;
   case 'X':
   default:
      return (c);
   }
   return ('\0');
}

/*-------------------------------- _upper --------------------------------*/
char _upper(char ch)
{
   if (ch>='a')
   {
      if(ch>'z')
      {
         if (ch=='')
            return('');
         else if (ch=='')
            return('');
         else if (ch=='')
            return('');
      }
      else
         return(ch-32);
   }

   return(ch);
}

/*-------------------------------- _lower --------------------------------*/
char _lower(char ch)
{
   if (ch>='A')
   {
      if(ch>'Z')
      {
         if (ch=='')
            return('');
         else if (ch=='')
            return('');
         else if (ch=='')
            return('');
      }
      else
         return(ch+32);
   }

   return(ch);
}

/*--------------------- DrawObjcTextCadre ---------------------------*/
void DrawObjcTextCadre(OBJECT *object, INT16 txt_x, INT16 txt_y)
{NEW_EDIT *newedit    = (NEW_EDIT*) object->ob_spec.userblk->ub_parm;
 TEDINFO  *tedinfo    = newedit->tedinfo;
 char         *tmpl   = tedinfo->te_ptmplt;
 INT16      thickness = tedinfo->te_thickness;
 char *pt_d,*pt_e,*pt_tmpl;
 INT16 vectxy[6];
 INT16 width_txt;
 char sav_car;
 EXTND_DIM strdim;
 
 
 
 if (  object->ob_flags & 0x0800 ||
       ((object->ob_flags & 0x0600) != 0x0600 &&   /* si seulement bit 9 ou bit 10 isol */
        object->ob_flags & 0x0600             &&   /* mais pas les deux  la fois        */
        thickness<0)                               /* et epaisseur cadre exterieure      */
    )
    {vsl_width (VDIhandle,1);
     vsl_type  (VDIhandle,1);
     vsl_ends  (VDIhandle,0,0);
     vswr_mode (VDIhandle,1);
     if (newedit->LenNewTxtAlloc)
        {vectxy[0] = txt_x-1;
         vectxy[1] = txt_y+3;
         vectxy[2] = vectxy[0];
         vectxy[3] = txt_y - newedit->height_txt - 3;
         vectxy[4] = txt_x + newedit->width_txt;
         vectxy[5] = vectxy[3];
         
         vsl_color (VDIhandle,1);
         v_pline   (VDIhandle, 3, vectxy);
         vectxy[4] = vectxy[0];
         vectxy[0] = txt_x + newedit->width_txt;
         vectxy[1] = vectxy[3];
         vectxy[2] = vectxy[0];
         vectxy[3] = txt_y+3;
         vectxy[5] = txt_y+3;
         if (Nb_plan>=4)       vsl_color (VDIhandle, 0);
         v_pline(VDIhandle, 3, vectxy);
        }
     else
        {
         pt_tmpl = tmpl;
         while (*pt_tmpl != 0)
            {
             pt_d = strchr(pt_tmpl,'_');
             if (pt_d !=0)
                {pt_e = pt_d;
                 /*........... avancer jusqu' la fin du champ .....*/
                 /*               et calcul X fin champ             */
                 while (*pt_e && *pt_e == '_')
                       {pt_e++;
                       }
                 sav_car = *pt_e;
                 *pt_e=0;
                 vqt_extent(VDIhandle, pt_tmpl, (INT16*)&strdim);
                 *pt_e=sav_car;
                 width_txt = (strdim.XinfD - strdim.XinfG);
                 /*........... calcul X debut champ ................*/
                 *pt_d = 0;
                 vqt_extent(VDIhandle, pt_tmpl, (INT16*)&strdim);
                 *pt_d = '_';
                 /*........... tracer le rectangle .................*/
                 vectxy[0] = txt_x + (strdim.XinfD - strdim.XinfG)-1;
                 vectxy[1] = txt_y+3;
                 vectxy[2] = vectxy[0];
                 vectxy[3] = txt_y - newedit->height_txt - 3;
                 vectxy[4] = txt_x + width_txt;
                 vectxy[5] = vectxy[3];
                 vsl_color (VDIhandle,1);
                 v_pline   (VDIhandle, 3, vectxy);
                 vectxy[4] = vectxy[0];
                 vectxy[0] = txt_x + width_txt;
                 vectxy[1] = vectxy[3];
                 vectxy[2] = vectxy[0];
                 vectxy[3] = txt_y+3;
                 vectxy[5] = txt_y+3;
                 if (Nb_plan>=4)
                     vsl_color (VDIhandle,0);
                 v_pline(VDIhandle, 3, vectxy);
                 txt_x += width_txt;
                }
             else
                {pt_e = pt_tmpl + strlen(pt_tmpl);
                }
             pt_tmpl =  pt_e;
            } /* end while */
        }/* endelse de if (newedit->LenNewTxtAlloc) */
    }  /* endif  object->ob_flags & 0x0800 ||...*/
}
/*------------------------- DrawObjcBlkEdit -------------------------*/
void DrawObjcBlkEdit(OBJECT *object, INT16 txt_x, INT16 txt_y )
{NEW_EDIT *newedit  = (NEW_EDIT*) object->ob_spec.userblk->ub_parm;
 if (newedit->LenNewTxtAlloc) DrawObjcBlkEdit_1(newedit, txt_x, txt_y );
 else                         DrawObjcBlkEdit_2(newedit, txt_x, txt_y );
}
/*------------------------- DrawObjcBlkEdit_1 -----------------------*/
/* ACTION: trace le bloc lorsque le template est compose que de '_'  */

void DrawObjcBlkEdit_1(NEW_EDIT* newedit, INT16 txt_x, INT16 txt_y )
{TEDINFO  *tedinfo  = newedit->tedinfo;
 char         *txt  = tedinfo->te_ptext;
 INT16       deb_x  = CarEditToX(txt, newedit->BlkDeb);
 INT16       end_x  = CarEditToX(txt, newedit->BlkEnd);
 INT16        ofsX  = 0;
 char          sav  = 0;
 EXTND_DIM strdim;
 INT16 vectxy[6];
 /*.............. mesurer l'ofset d'affichage .......................*/
 sav  = txt[newedit->LeftOfset]; txt[newedit->LeftOfset] = 0;
 vqt_extent(VDIhandle, txt, (INT16*)&strdim);
 ofsX = (strdim.XinfD - strdim.XinfG);
 txt[newedit->LeftOfset] = sav;
 /*.............. calcul des positions graphiques du bloc ...........*/
 deb_x -= ofsX;
 end_x -= ofsX;
 if (deb_x > end_x) SWAPW(deb_x, end_x);
 if (deb_x > newedit->width_txt)             return;  /* pas visible */
 if (end_x < 0)                              return;  /* pas visible */
 deb_x = Max(deb_x, 0 );
 end_x = Min(end_x, newedit->width_txt);
 vswr_mode   (VDIhandle,3);
 vsf_color   (VDIhandle,1);
 vsf_interior(VDIhandle,FIS_SOLID);
 vectxy[0] = txt_x + deb_x;
 vectxy[1] = txt_y - newedit->height_txt-1;
 vectxy[2] = txt_x + end_x - 1;
 vectxy[3] = txt_y;
 vr_recfl(VDIhandle,vectxy);
}

/*------------------------- DrawObjcBlkEdit_2 -----------------------*/
/* ACTION: trace le bloc lorsque le template peut etre mixte         */

void DrawObjcBlkEdit_2(NEW_EDIT* newedit, INT16 txt_x, INT16 txt_y )
{TEDINFO  *tedinfo  = newedit->tedinfo;
 char         *tmpl = tedinfo->te_ptmplt;
 char *pt_d,*pt_e,*pt_tmpl,*ptBlkDeb,*ptBlkEnd;
 INT16 vectxy[6];
 INT16 EndChp,BlkDeb,BlkEnd;
 INT16 width_txt;
 char sav_car;
 EXTND_DIM strdim;

 ptBlkDeb  = 0;
 ptBlkEnd  = 0;
 EndChp    = 0;
 BlkDeb    = newedit->BlkDeb;
 BlkEnd    = newedit->BlkEnd;
 if (BlkDeb>BlkEnd) SWAPW(BlkDeb, BlkEnd);
 vswr_mode   (VDIhandle,3);
 vsf_color   (VDIhandle,1);
 vsf_interior(VDIhandle,FIS_SOLID);

 pt_tmpl = tmpl;
 while (*pt_tmpl != 0)
   {pt_d = strchr(pt_tmpl,'_');
    if (pt_d !=0)
       {pt_e = pt_d;

        /*........... calcul X fin champ ..................*/
        while (*pt_e && *pt_e == '_')
              {if (EndChp == BlkDeb) ptBlkDeb = pt_e;
               if (EndChp == BlkEnd) ptBlkEnd = pt_e;
               EndChp++;
               pt_e++;
              }

        if (ptBlkEnd && ptBlkEnd<pt_e)  /*.... SI fin bloc dans ce champ ..........*/
           {sav_car = *ptBlkEnd;        /*     Xfin est sur ce caractere           */
            *ptBlkEnd=0;
           }
        else                            /*.... SI fin bloc pas dans ce champ ......*/
           {sav_car = *pt_e;            /*     Xfin est fin champ                  */
            *pt_e=0;
           }
        vqt_extent(VDIhandle, pt_tmpl, (INT16*)&strdim);
        if (ptBlkEnd && ptBlkEnd<pt_e) *ptBlkEnd=sav_car;
        else                           *pt_e=sav_car;
        width_txt = (strdim.XinfD - strdim.XinfG);

        /*........... calcul X debut champ ................*/
        if (ptBlkDeb && ptBlkDeb>pt_d)  /*.... SI Deb bloc dans ce champ ..........*/
           {sav_car = *ptBlkDeb;        /*     Xdeb est sur ce caractere           */
            *ptBlkDeb=0;
           }
        else                            /*.... SI Deb bloc pas dans ce champ ......*/
           {sav_car = *pt_d;            /*     Xdeb est debut champ                */
            *pt_d=0;
           }
        vqt_extent(VDIhandle, pt_tmpl, (INT16*)&strdim);
        if (ptBlkDeb && ptBlkDeb>pt_d) *ptBlkDeb=sav_car;
        else                           *pt_d=sav_car;

        /*........... tracer le rectangle .................*/
        if (ptBlkDeb || ptBlkEnd)
           {vectxy[0] = txt_x + (strdim.XinfD - strdim.XinfG);
            vectxy[1] = txt_y - newedit->height_txt -1;
            vectxy[2] = txt_x + width_txt;
            vectxy[3] = txt_y ;
            vr_recfl(VDIhandle,vectxy);
           }
        /*........... debut ou fin qu'une fois dans un champ ......*/
        if (ptBlkEnd) return;
        txt_x += width_txt;
       }
     else
       {pt_e = pt_tmpl + strlen(pt_tmpl);
       }
     pt_tmpl =  pt_e;
   } /* end while */
}
/*------------------------- CarEditToX ------------------------------*/
INT16 CarEditToX(char *txt, int pos_car)
{char         *pt = txt;
 char        *car = "";
 INT16       newx = 0;
 EXTND_DIM strdim;
 while (*pt)
       {if ( (INT16)(pt - txt) >= pos_car) return newx;
        *car = *pt;
        vqt_extent(VDIhandle, car, (INT16*)&strdim);
        newx += strdim.XinfD - strdim.XinfG;
        pt++;
       }
 return newx;
}

/*------------------------- MousexToCarEdit -------------------------*/
INT16 MousexToCarEdit( OBJECT *object, INT16 ind, INT16 mx)
{EXTND_DIM strdim;
 TEDINFO  *tedinfo;
 NEW_EDIT *newedit;
 INT16 ob_x, ob_y;
 INT16 txt_x; /* txt_y; */
 char *tmpl,*txt, *pt_tmpl;
 INT16 width_txt,just,te_fnt;
 INT16 i;
 INT16 oldx,newx;
 char car[2];

 #ifdef __TXT_PROC__
 if (GET_XOBTYPE(object, ind) == SCROLL_EDIT) return -1;
 #endif

 /*............. position de l'objet editable .......................*/
 objc_offset(object, ind, &ob_x, &ob_y);
 /*............. recuperer tedinfo et autres variables ..............*/
 object=&object[ind];
 newedit   = (NEW_EDIT*) object->ob_spec.userblk->ub_parm;
 tedinfo   = newedit->tedinfo;
 txt       = tedinfo->te_ptext;
 tmpl      = tedinfo->te_ptmplt;
 just      = tedinfo->te_just;
 te_fnt    = tedinfo->te_font;
 
 /*........ determiner le texte .....................................*/
 SetSystemFont(object, te_fnt);

 /*................. determiner la taille caractere .................*/
 vqt_extent(VDIhandle,tmpl,(INT16*)&strdim);
 width_txt = strdim.XinfD - strdim.XinfG;
 switch (just)
 {case 0: txt_x = ob_x;                                        break;
  case 1: txt_x = ob_x +   object->ob_width - width_txt;       break;
  case 2: txt_x = ob_x + ((object->ob_width - width_txt)>>1);  break;
 }
 /* txt_y = ob_y + (object->ob_height >>1) + ((strdim.YsupD-strdim.YinfD)>>1) - 1; */

 pt_tmpl = tmpl;
 i= newedit->LeftOfset;
 car[1]=0;         /* mettre zero de fin de la chaine tampon */
 oldx=newx=txt_x;
 while (txt[i])
       {*car= *pt_tmpl;      /* noter largeur car */
        vqt_extent(VDIhandle,car,(INT16*)&strdim);
        newx += strdim.XinfD - strdim.XinfG;
        if (mx>oldx && mx<=newx) return i;
        if (*pt_tmpl == '_') i++; /* compter nbr car editable   */
        pt_tmpl++;                /* avancer de un sur template */
        oldx=newx;
       }
return i;
}

/*------------------------ EditableTextMix -------------------------*/
INT16 EditableTextMix(char *txt, char *tmpl, char *buft, INT16 poscur)
{char *pt_txt, *pt_buft, *pt_tmpl;
 INT16 i;
 pt_txt  = txt;
 pt_buft = buft;
 pt_tmpl = tmpl;
 /*..................*/
 i=-1;
 while (*pt_tmpl)
   {if (*pt_tmpl=='_')
       {if (*pt_txt)
           {*pt_buft=*pt_txt;

            if ((INT16)(pt_txt-txt) == poscur) i=(INT16)(pt_buft-buft);

            pt_txt++;
           }
        else
           {if (i==-1) i=(INT16)(pt_buft-buft);
            /* *pt_buft='_'; */
            *pt_buft=' ';
           }
       }
    else
       {*pt_buft=*pt_tmpl;
       }
    pt_buft ++;
    pt_tmpl++;
   }
 *pt_buft = 0; /* placer zero de fin */
 if (i==-1)
    {while (pt_tmpl[-1] != '_' && pt_tmpl>tmpl)pt_tmpl--;
     i= (INT16)(pt_tmpl- tmpl);
    }
 return i;
}

/*------------------------- UserEditableDraw ---------------------------------------*/
/* typedef struct                     */
/* {                                  */
/*         OBJECT  *pb_tree;          */           /* Zeiger auf den Objektbaum     */
/*         INT16     pb_obj;            */           /* Nummer des Objekts            */
/*         INT16     pb_prevstate;      */           /* vorheriger Objektstatus       */
/*         INT16     pb_currstate;      */           /* neuer Objektstatus            */
/*         INT16     pb_x, pb_y, pb_w, pb_h;      */ /* Objektkoordinaten   */
/*         INT16     pb_xc, pb_yc, pb_wc, pb_hc;  */ /* Clipping-Koordinate */
/*         long    pb_parm;                 */     /* der optionale Parameter aus der*/
/* } PARMBLK;                               */     /* USERBLK-struktur               */

INT16 cdecl UserEditableDraw(PARMBLK *parmblock)
{OBJECT    *object = parmblock->pb_tree;
 INT16         ind = parmblock->pb_obj;
 NEW_EDIT *newedit = (NEW_EDIT*) parmblock->pb_parm;
 TEDINFO  *tedinfo = newedit->tedinfo;
 INT16    xob_type = (object[ind].ob_type>>8) & 0x00FF; /* G_FBOXTEXT  G_FTEXT */
 char         *txt = tedinfo->te_ptext;
 char        *tmpl = tedinfo->te_ptmplt;
 INT16        ob_x = parmblock->pb_x;
 INT16        ob_y = parmblock->pb_y;
 INT16        ob_w = parmblock->pb_w;
 INT16        ob_h = parmblock->pb_h;
 INT16   thickness = tedinfo->te_thickness;
 GRECT       grect;
 INT16 i;
 INT16 txt_x, txt_y;
 INT16 vectxy [16];
 char  buft[512];

 /*........ clipper selon coordonnees de cliping ....................*/
 ClipGrect((GRECT*)&parmblock->pb_xc);
 /*.......... corriger la position reelle de l'objet ..............*/
 if (object[ind].ob_flags & 0x0800) thickness = -4; /* texte encadre */
 if (thickness<0)
    {ObjcOFsetToCoord(&ob_x,
                      &ob_y,
                      &ob_w,
                      &ob_h,
                      thickness-1,
                      1);
    }
 
 /*........ determiner le texte .....................................*/
 SetSystemFont(object, tedinfo->te_font);
 
 switch (tedinfo->te_just)
 {case 0: txt_x = ob_x;                                     break;
  case 1: txt_x = ob_x +   ob_w - newedit->width_txt;       break;
  case 2: txt_x = ob_x + ((ob_w - newedit->width_txt)>>1);  break;
 }

 txt_y = ob_y + (ob_h >>1) + (newedit->height_txt>>1) ;
 if (object[ind].ob_state & SELECTED)
    {txt_x++;
     txt_y++;
    }
 
 /*.................... determination du fond .......................*/
 SetObjcInterior(&object[ind]);
 /*......... dessiner fond et cadre exterrieur ......................*/
 vswr_mode(VDIhandle,1);
 if (xob_type == G_FBOXTEXT || xob_type == NEW_BUTTON)
    {vectxy[0] = ob_x;
     vectxy[1] = ob_y;
     vectxy[2] = ob_x + ob_w + 1;
     vectxy[3] = ob_y + ob_h + 1;
     vr_recfl(VDIhandle,vectxy);
     DrawObjcCadre(&object[ind], parmblock);
    }
 
 /*...........mixer template et chaine ..............................*/
 if (xob_type == NEW_BUTTON)
    {/*.............................. afficher le texte .............*/
     if (tedinfo->te_color& 0x0080) i=1;       /* mode replace       */
     else                           i=2;       /* mode transparent   */
     if (object[ind].ob_flags&0x0800)  /* bit 14 */
        {XtextObAffi(txt_x+1, txt_y+1, txt, 0,i);
        }
     XtextObAffi(txt_x, txt_y, txt, (tedinfo->te_color>>8)&0x000F,i);
     return 0;
    }
 grect.g_x = txt_x - 1;
 grect.g_y = txt_y - newedit->height_txt - 3;
 grect.g_w = newedit->width_txt  + 2;
 grect.g_h = newedit->height_txt + 7;
 
 
 if (Rc_intersect((GRECT*)&parmblock->pb_xc, &grect)==0) return 0;
 ClipGrect( &grect);
 EditableTextMix(txt, tmpl, buft, 0);
 /*.............................. afficher le texte .................*/
 if (tedinfo->te_color& 0x0080) i=1;       /* mode replace           */
 else                           i=2;       /* mode transparent       */
 XtextObAffi(txt_x, txt_y, buft + newedit->LeftOfset, (tedinfo->te_color>>8)&0x000F, i);
 /*................... afficher cadre autour texte ..................*/
 if (xob_type == G_FBOXTEXT)
     DrawObjcTextCadre(&object[ind], txt_x, txt_y );
 if (newedit->BlkDeb != newedit->BlkEnd)
     DrawObjcBlkEdit(&object[ind],txt_x, txt_y );
 vswr_mode(VDIhandle,1);       /* mode replace       */
 vst_alignment (VDIhandle,0,0, &i, &i );
 return(0);
}

/*-------------------------- XtextObAffi --------------------------------*/
void XtextObAffi(INT16 txt_x, INT16 txt_y, char *txt, INT16 color, INT16 w_mode)
{char racc[2]={0,0};
 char *car;
 EXTND_DIM strdim;
 vswr_mode(VDIhandle,w_mode);                  /* placer mode ecriture texte          */
 vst_color(VDIhandle,color);
 car = strchr(txt,'[');                        /* rechercher raccourci                */
 if (car!=0L && car[1] !=0)
    {
     *car = 0;                                 /* couper au caractere de soulignement */
     vqt_extent(VDIhandle,txt,(INT16*)&strdim);  /* larg prem segment texte             */
     v_gtext(VDIhandle,txt_x,txt_y,txt);       /* afficher premier segment            */
     txt_x += strdim.XinfD - strdim.XinfG;     /* mise  jour position affi X         */
     *racc = car[1];                           /* relever le raccourci                */
     vqt_extent(VDIhandle,racc,(INT16*)&strdim); /* largeur raccourci                   */
     if (color !=0) vst_color(VDIhandle,4);    /* couleur raccourci                   */
     v_gtext(VDIhandle,txt_x,txt_y,racc);      /* afficher raccourci                  */
     if (color !=0)
        {vswr_mode(VDIhandle,1);               /* mode affi replace                   */
         vsl_ends(VDIhandle,0,0);              /* afficher ligne souligne            */
         vsl_width(VDIhandle,1);
         vsl_type(VDIhandle,1);
         vsl_color(VDIhandle,2);
         Line_p (txt_x,txt_y+1,txt_x+strdim.XinfD - strdim.XinfG-2,txt_y+1);
         vswr_mode(VDIhandle,w_mode);          /* replacer mode ecriture texte        */
        }
     txt_x += strdim.XinfD - strdim.XinfG;     /* mise  jour position affi X         */
     vst_color(VDIhandle,color);               /* couleur deuxieme segment            */
     v_gtext(VDIhandle,txt_x,txt_y,car+2);     /* afficher deuxieme segment           */
     *car='[';
    }
 else
    {v_gtext(VDIhandle,txt_x,txt_y,txt);
    }
}
/*------------------------------ FindDebMot -------------------------*/
INT16 FindDebMot(char *txt, INT16 i)
{char *pt;
 pt=txt+i;
 while(pt>txt && pt[-1] != 32)pt--;
 return (INT16) (pt-txt);
}
/*------------------------------ FindEndMot -------------------------*/
INT16 FindEndMot(char *txt, INT16 i)
{char *pt;
 pt=txt+i;
 while(*pt && *pt != 32) pt++;
 return (INT16) (pt-txt);
}